// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#include "../../config.h"
#include <strstream.h>
#include <sqlrclient.h>
#include <stdlib.h>
#include <time.h>

int main(int argc, char **argv) {

	if (argc<6) {
		cout << "usage: sqlrtest host port socket user password query iterations" << endl;
		exit(0);
	}

	char	*host=argv[1];
	char	*port=argv[2];
	char	*socket=argv[3];
	char	*user=argv[4];
	char	*password=argv[5];
	char	*query=argv[6];
	int	iterations=atoi(argv[7]);

	time_t	starttime=time(NULL);
	cout << "sqlrtest running, please wait..." << endl;
	clock();

	for (int count=0; count<iterations; count++) {
		sqlrclient	*sqlrc=new sqlrclient(host,atoi(port),socket,
							user,password,0,1);
		sqlrc->sendQuery(query);
		sqlrc->endSession();
		for (int i=0; i<sqlrc->rowCount(); i++) {
			for (int j=0; j<sqlrc->colCount(); j++) {
				cout << "\"" << sqlrc->getField(i,j) << "\",";
			}
			cout << endl;
		}
		delete sqlrc;
	}

	cout << "total system time used : " << clock() << endl;
	cout << "total real time : " << time(NULL)-starttime << endl;
}
