// Copyright (c) 1999-2000  David Muse
// See the file COPYING for more information.


		int	openSession();
		void	closeConnection();

		void	handleAuthentication();
		int	getNewPort();

		void	clearConnectionPorts();
		void	clearResultSet();
		void	clearCacheDest();
		void	clearCacheSource();
		void	clearError();
		void	clearColumns();
		void	clearRowBuffers();
		void	clearSessionFlags();
		void	clearVariables();
		void	initVariables();
		void	deleteVariables();

		void	initQueryBuffer();
		int	sendQueryInternal(char *query);
		void	validateBindsInternal(char *query);
		void	sendInputBinds();
		void	sendOutputBinds();
		void	stringVar(bindvar *var, char *variable, char *value);
		void	longVar(bindvar *var, char *variable, long value);
		void	doubleVar(bindvar *var, char *variable, 
						double value,
						short precision,
						short scale);
		void	initVar(bindvar *var, char *variable);
		int	runQuery(char *query);
		void	abortResultSet();
		void	suspendResultSet();
		int	processResultSet();
		int	processResultSet(int rowtoget, int offset);

		int	getChar(char *character);
		int	getString(char *string, int size);
		int	getShort(short *integer);
		int	getLong(long *integer);

		int	parseHeader();
		int	parseOutputBinds();
		int	parseData(int rowtoget, int offset);
		void	handleError(char *err);

		void	fetchRows();
		void	jumpToOffset(int offset);
		void	skipRows(int rowtoget);

		void	startCaching();
		void	cacheHeader();
		void	cacheOutputBinds(int count);
		void	cacheData();
		void	finishCaching();
		void	suspendCaching();
 
		int	fetchRowIntoBuffer(int row);

		void	createColumnArrays();
		void	createFieldArray();

		void	debugPrint(char *string);
		void	debugPrint(long number);
		void	debugPrint(double number);

		// session state
		short		endsessionsent;
		short		suspendsessionsent;
		int		connected;
		int		cached;
		int		resumed;

		// connection
		char			*server;
		unsigned short		listenerinetport;
		unsigned short		connectioninetport;
		char			*listenerunixport;
		char			*connectionunixport;
		char			connectionunixportbuffer[MAXPATHLEN+1];
		int			retrytime;
		int			tries;

		// authentication
		char		*user;
		int		userlen;
		char		*password;
		int		passwordlen;

		// query
		char		*querybuffer;
		char		*queryptr;
		char		*fullpath;

		// substitution variables
		bindvar		subvars[MAXVAR];
		int		subcount;

		// bind variables
		bindvar		inbindvars[MAXVAR];
		int		inbindcount;
		bindvar		outbindvars[MAXVAR];
		int		outbindcount;
		int		validatebinds;

		// result set
		long		rsbuffersize;

		long		firstrowindex;
		long		colcount;
		long		rowcount;
		long		totalrows;
		long		affectedrows;
		short		endofresultset;

		column		*firstcol;
		column		*currentcol;

		row		*firstrow;
		row		*currentrow;

		column		**columnarray;
		char		**columnnamearray;
		char		***fieldarray;

		int		returnnulls;

		char		*id;

		// result set caching
		int		cacheon;
		int		cachettl;
		strstream	*cachedestname;
		ofstream	*cachedestfd;
		static	int	cachefilesequence;
		int		cachesourcefd;

		// error
		char		*error;

		// debug
		short		debug;
		int		(*printfunction)(const char *,...);

		// copy references flag
		int		copyrefs;

	public:
		void		copyReferences();
