/* Copyright (c) 2000  David Muse
   See the file COPYING for more information */

#include <sqlrclient.h>
#include <fstream.h>
#include <strstream.h>

extern "C" {
	#undef __cplusplus
	#include <string.h>
	#include <stdarg.h>
	#ifdef HAVE_STRINGS_H
		#include <strings.h>
	#endif
	#define __cplusplus

#include <sqlrclientwrapper.h>

sqlrc	sqlrc_alloc(char *server, int port, char *socket,
				char *user, char *password, 
				int retrytime, int tries) {
	sqlrclient	*sqlrcref=new sqlrclient(server,port,socket,
					user,password,retrytime,tries);
	return (sqlrc)sqlrcref;
}

void	sqlrc_free(sqlrc sqlrcref) {
	delete (sqlrclient *)sqlrcref;
}

void	sqlrc_setResultSetBufferSize(sqlrc sqlrcref, int rows) {
	((sqlrclient *)sqlrcref)->setResultSetBufferSize(rows);
}

int	sqlrc_getResultSetBufferSize(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->getResultSetBufferSize();
}

int	sqlrc_ping(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->ping();
}

void	sqlrc_cacheOn(sqlrc sqlrcref) {
	((sqlrclient *)sqlrcref)->cacheOn();
}

void	sqlrc_setCacheTtl(sqlrc sqlrcref, int ttl) {
	((sqlrclient *)sqlrcref)->setCacheTtl(ttl);
}

void	sqlrc_cacheOff(sqlrc sqlrcref) {
	((sqlrclient *)sqlrcref)->cacheOff();
}

char	*sqlrc_identify(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->identify();
}

int	sqlrc_sendQuery(sqlrc sqlrcref, char *query) {
	return ((sqlrclient *)sqlrcref)->sendQuery(query);
}

int	sqlrc_sendFileQuery(sqlrc sqlrcref, char *path, char *filename) {
	return ((sqlrclient *)sqlrcref)->sendFileQuery(path,filename);
}

void	sqlrc_prepareQuery(sqlrc sqlrcref, char *query) {
	((sqlrclient *)sqlrcref)->prepareQuery(query);
}

void	sqlrc_prepareFileQuery(sqlrc sqlrcref, char *path, char *filename) {
	((sqlrclient *)sqlrcref)->prepareFileQuery(path,filename);
}

void	sqlrc_subString(sqlrc sqlrcref, char *variable, char *value) {
	((sqlrclient *)sqlrcref)->substitution(variable,value);
}

void	sqlrc_subLong(sqlrc sqlrcref, char *variable, long value) {
	((sqlrclient *)sqlrcref)->substitution(variable,value);
}

void	sqlrc_subDouble(sqlrc sqlrcref, char *variable, double value, 
					short precision, short scale) {
	((sqlrclient *)sqlrcref)->substitution(variable,value,precision,scale);
}

void	sqlrc_inputBindString(sqlrc sqlrcref, char *variable, char *value) {
	((sqlrclient *)sqlrcref)->inputBind(variable,value);
}

void	sqlrc_inputBindLong(sqlrc sqlrcref, char *variable, long value) {
	((sqlrclient *)sqlrcref)->inputBind(variable,value);
}

void	sqlrc_inputBindDouble(sqlrc sqlrcref, char *variable, double value,
					short precision, short scale) {
	((sqlrclient *)sqlrcref)->inputBind(variable,value,precision,scale);
}

void	sqlrc_subStrings(sqlrc sqlrcref, char **variables, char **values) {
	((sqlrclient *)sqlrcref)->substitutions(variables,values);
}

void	sqlrc_subLongs(sqlrc sqlrcref, char **variables, long *values) {
	((sqlrclient *)sqlrcref)->substitutions(variables,values);
}

void	sqlrc_subDoubles(sqlrc sqlrcref, char **variables, double *values,
					short *precisions, short *scales) {
	((sqlrclient *)sqlrcref)->substitutions(variables,values,
						precisions,scales);
}

void	sqlrc_inputBindStrings(sqlrc sqlrcref, char **variables, 
							char **values) {
	((sqlrclient *)sqlrcref)->inputBinds(variables,values);
}

void	sqlrc_inputBindLongs(sqlrc sqlrcref, char **variables, long *values) {
	((sqlrclient *)sqlrcref)->inputBinds(variables,values);
}

void	sqlrc_inputBindDoubles(sqlrc sqlrcref, 
					char **variables, double *values,
					short *precisions, short *scales) {
	((sqlrclient *)sqlrcref)->inputBinds(variables,values,
					     	precisions,scales);
}

void	sqlrc_validateBinds(sqlrc sqlrcref) {
	((sqlrclient *)sqlrcref)->validateBinds();
}

int	sqlrc_executeQuery(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->executeQuery();
}

void	sqlrc_defineOutputBind(sqlrc sqlrcref, char *variable, int length) {
	((sqlrclient *)sqlrcref)->defineOutputBind(variable,length);
}

char	*sqlrc_getOutputBind(sqlrc sqlrcref, char *variable) {
	((sqlrclient *)sqlrcref)->getOutputBind(variable);
}


char	*sqlrc_getCacheFileName(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->getCacheFileName();
}

int	sqlrc_openCachedResultSet(sqlrc sqlrcref, char *filename) {
	return ((sqlrclient *)sqlrcref)->openCachedResultSet(filename);
}

int	sqlrc_openCachedResultSetWithOffset(sqlrc sqlrcref, char *filename,
					int offset, int row) {
	return ((sqlrclient *)sqlrcref)->openCachedResultSet(filename);
}

int	sqlrc_endSession(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->endSession();
}

int	sqlrc_suspendSession(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->suspendSession();
}

int	sqlrc_resumeSession(sqlrc sqlrcref, int port, char *socket) {
	return ((sqlrclient *)sqlrcref)->resumeSession(port,socket);
}

int	sqlrc_resumeCachedSession(sqlrc sqlrcref, int port, char *socket, 
							char *cachefilename) {
	return ((sqlrclient *)sqlrcref)->resumeCachedSession(port,socket,
							cachefilename);
}

int	sqlrc_getConnectionPort(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->getConnectionPort();
}

char	*sqlrc_getConnectionSocket(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->getConnectionSocket();
}

int	sqlrc_getCacheFileOffset(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->getCacheFileOffset();
}

int	sqlrc_rowCount(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->rowCount();
}

int	sqlrc_colCount(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->colCount();
}

int	sqlrc_totalRows(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->totalRows();
}

int	sqlrc_affectedRows(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->affectedRows();
}

int	sqlrc_firstRowIndex(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->firstRowIndex();
}

char	*sqlrc_errorMessage(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->errorMessage();
}

void	sqlrc_getNullsAsEmptyStrings(sqlrc sqlrcref) {
	((sqlrclient *)sqlrcref)->getNullsAsEmptyStrings();
}

void	sqlrc_getNullsAsNulls(sqlrc sqlrcref) {
	((sqlrclient *)sqlrcref)->getNullsAsNulls();
}

char	*sqlrc_getFieldByIndex(sqlrc sqlrcref, int row, int col) {
	return ((sqlrclient *)sqlrcref)->getField(row,col);
}

char	*sqlrc_getFieldByName(sqlrc sqlrcref, int row, char *col) {
	return ((sqlrclient *)sqlrcref)->getField(row,col);
}

char	**sqlrc_getRow(sqlrc sqlrcref, int row) {
	return ((sqlrclient *)sqlrcref)->getRow(row);
}

char	**sqlrc_getColumnNames(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->getColumnNames();
}

char	*sqlrc_getColumnName(sqlrc sqlrcref, int col) {
	return ((sqlrclient *)sqlrcref)->getColumnName(col);
}

char	*sqlrc_getColumnTypeByIndex(sqlrc sqlrcref, int col) {
	return ((sqlrclient *)sqlrcref)->getColumnType(col);
}

int	sqlrc_getColumnLengthByIndex(sqlrc sqlrcref, int col) {
	return ((sqlrclient *)sqlrcref)->getColumnLength(col);
}

char	*sqlrc_getColumnTypeByName(sqlrc sqlrcref, char *col) {
	return ((sqlrclient *)sqlrcref)->getColumnType(col);
}

int	sqlrc_getColumnLengthByName(sqlrc sqlrcref, char *col) {
	return ((sqlrclient *)sqlrcref)->getColumnLength(col);
}

int	sqlrc_getLongestByName(sqlrc sqlrcref, char *col) {
	return ((sqlrclient *)sqlrcref)->getLongest(col);
}

int	sqlrc_getLongestByIndex(sqlrc sqlrcref, int col) {
	return ((sqlrclient *)sqlrcref)->getLongest(col);
}

void	sqlrc_debugOn(sqlrc sqlrcref) {
	((sqlrclient *)sqlrcref)->debugOn();
}

void	sqlrc_debugOff(sqlrc sqlrcref) {
	((sqlrclient *)sqlrcref)->debugOff();
}

int	sqlrc_getDebug(sqlrc sqlrcref) {
	return ((sqlrclient *)sqlrcref)->getDebug();
}

void	sqlrc_debugPrintFunction(sqlrc sqlrcref,
				int (*printfunction)(const char *,...)) {
	((sqlrclient *)sqlrcref)->debugPrintFunction(printfunction);
}

void	sqlrc_copyReferences(sqlrc sqlrcref) {
	((sqlrclient *)sqlrcref)->copyReferences();
}

}
