/* Copyright (c) 2000  David Muse
   See the file COPYING for more information */
   
#include "../c++/include/sqlrclient.h"
#include "../c++/src/sqlrclient.C"

extern "C" {
	#include <EXTERN.h>
	#include <perl.h>
	#include <XSUB.h>
	#include "Av_CharPtrPtr.h"
}

#undef bool

#ifndef na
	#define na PL_na
#endif

typedef class sqlrclient sqlrclient;

MODULE = Firstworks::SQLRClient		PACKAGE = Firstworks::SQLRClient
REQUIRE: 1.925

sqlrclient *
sqlrclient::new(server,port,socket,user,password,retrytime,tries)
		char *server
		int port
		char *socket
		char *user
		char *password
		int retrytime
		int tries
	CODE:
		RETVAL=new sqlrclient(server,port,socket,
					user,password,retrytime,tries);
		RETVAL->copyReferences();
	OUTPUT:
		RETVAL

	

void
sqlrclient::DESTROY()

void
sqlrclient::setResultSetBufferSize(rows)
		int rows

int
sqlrclient::getResultSetBufferSize()

int
sqlrclient::ping()

char *
sqlrclient::identify()

void
sqlrclient::cacheOn()

void
sqlrclient::setCacheTtl(ttl)
		int ttl

char *
sqlrclient::getCacheFileName()

void
sqlrclient::cacheOff()

int
sqlrclient::sendQuery(query)
		char *query

int
sqlrclient::sendFileQuery(path,file)
		char *path
		char *file

void
sqlrclient::prepareQuery(query)
		char *query
		

void
sqlrclient::prepareFileQuery(path,file)
		char *path
		char *file

void
sqlrclient::substitution(variable,...)
		char *variable
	CODE:
		if (SvIOK(ST(2))) {
			THIS->substitution(variable,(long)SvIV(ST(2)));
		} else if (SvNOK(ST(2))) {
			THIS->substitution(variable,(double)SvNV(ST(2)),
						(short)SvIV(ST(3)),
						(short)SvIV(ST(4)));
		} else if (SvPOK(ST(2))) {
			THIS->substitution(variable,SvPV(ST(2),PL_na));
		}

void
sqlrclient::inputBind(variable,...)
		char *variable
	CODE:
		if (SvIOK(ST(2))) {
			THIS->inputBind(variable,(long)SvIV(ST(2)));
		} else if (SvNOK(ST(2))) {
			THIS->inputBind(variable,(double)SvNV(ST(2)),
						(short)SvIV(ST(3)),
						(short)SvIV(ST(4)));
		} else if (SvPOK(ST(2))) {
			THIS->inputBind(variable,SvPV(ST(2),PL_na));
		}

void
sqlrclient::validateBinds()

int
sqlrclient::executeQuery()

void
sqlrclient::defineOutputBind(variable,length)
		char *variable
		int length

char *
sqlrclient::getOutputBind(variable)
		char *variable

int
sqlrclient::openCachedResultSet(filename)
	char	*filename

int
sqlrclient::openCachedResultSetWithOffset(filename,offset,row)
		char	*filename
		int	offset
		int	row
	CODE:
		RETVAL=THIS->openCachedResultSet(filename,offset,row);
	OUTPUT:
		RETVAL

void
sqlrclient::endSession()

void
sqlrclient::suspendSession()

int
sqlrclient::resumeSession(port,socket)
		int	port
		char	*socket

int
sqlrclient::resumeCachedSession(port,socket,cachefilename)
		int	port
		char	*socket
		char	*cachefilename

int
sqlrclient::getConnectionPort()

char *
sqlrclient::getConnectionSocket()

int
sqlrclient::getCacheFileOffset()

int
sqlrclient::colCount()

int
sqlrclient::rowCount()

int
sqlrclient::totalRows()

int
sqlrclient::affectedRows()

int
sqlrclient::firstRowIndex()

char *
sqlrclient::errorMessage()

void
sqlrclient::getNullsAsEmptyStrings()

void
sqlrclient::getNullsAsUndefined()
	CODE:
		THIS->getNullsAsNulls();

char *
sqlrclient::getField(row,...)
		int	row
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(2)) || SvNOK(ST(2))) {
			RETVAL=THIS->getField(row,(int)SvIV(ST(2)));
		} else if (SvPOK(ST(2))) {
			RETVAL=THIS->getField(row,SvPV(ST(2),PL_na));
		}
	OUTPUT:
		RETVAL

char **
sqlrclient::getRow(row)
		int row
	PPCODE:
		int	index=0;
		char	**rowptr=THIS->getRow(row);
		EXTEND(SP,THIS->colCount());
		while (rowptr[index]) {
			PUSHs(sv_2mortal(newSVpv(rowptr[index],0)));
			index++;
		}

char **
sqlrclient::getColumnNames()
	PPCODE:
		int	index=0;
		char	**namesptr=THIS->getColumnNames();
		EXTEND(SP,THIS->colCount());
		while (namesptr[index]) {
			PUSHs(sv_2mortal(newSVpv(namesptr[index],0)));
			index++;
		}

char *
sqlrclient::getColumnName(col)
		int col

char *
sqlrclient::getColumnType(...)
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(1)) || SvNOK(ST(1))) {
			RETVAL=THIS->getColumnType((int)SvIV(ST(1)));
		} else if (SvPOK(ST(1))) {
			RETVAL=THIS->getColumnType(SvPV(ST(1),PL_na));
		}
	OUTPUT:
		RETVAL

int
sqlrclient::getColumnLength(...)
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(1)) || SvNOK(ST(1))) {
			RETVAL=THIS->getColumnLength((int)SvIV(ST(1)));
		} else if (SvPOK(ST(1))) {
			RETVAL=THIS->getColumnLength(SvPV(ST(1),PL_na));
		}
	OUTPUT:
		RETVAL

int
sqlrclient::getLongest(...)
	CODE:
		RETVAL=NULL;
		if (SvIOK(ST(1)) || SvNOK(ST(1))) {
			RETVAL=THIS->getLongest((int)SvIV(ST(1)));
		} else if (SvPOK(ST(1))) {
			RETVAL=THIS->getLongest(SvPV(ST(1),PL_na));
		}
	OUTPUT:
		RETVAL

void
sqlrclient::debugOn()

void
sqlrclient::debugOff()

int
sqlrclient::getDebug()
