import SQLRelay, DateTime
from SQLRelay import PySQLRDB
from Shared.DC.ZRDB.TM import TM

import string, sys
from string import strip, split, find
from time import time

failures=0
calls=0
last_call_time=time()

class DB(TM):

    Database_Error = PySQLRDB.DatabaseError
    Database_Connection=PySQLRDB.connect

    def __init__(self,connection):
        self.connection=connection
        info = string.split(connection)
        if info and len(info) == 4 or len(info) == 5:
            self.dbhost = info[0]
            self.user = info[2]
            self.password = info[3]
            self.port = info[1]
            self.unix_sockets = 0
            #c=PySQLRDB.connect((dbhost, string.atoi(port)), user, password)
            #self.db=c
            #self.cursor=c.cursor()
            if len(info) > 4:
                PySQLRDB.switch_api('pure')
            else:
                PySQLRDB.switch_api('c')
            return
        elif info and len(info) == 3:
            self.unix_sockets = 1
            self.unix_socket = info[0]
            self.user = info[1]
            self.password = info[2]
            #c=PySQLRDB.connect(unix_socket, user, password)
            #self.db=c
            #self.cursor=c.cursor()
            return
        raise self.Database_Error, (
            'Invalid connection stringy, <code>%s</code>.\n'
            'The connection should consist of a hostname, port number, \n'
            'user name, and password separated by spaces.\n'
            )

    def str(self,v, StringType=type('')):
        if v is None: return ''
        r=str(v)
        if r[-1:]=='L' and type(v) is not StringType: r=r[:-1]
        return r

    def _finish(self, *ignored):
	# since we use final queries sqlrelay commits for us
	#	        d,c = self.__get_con()
        #d.commit()
        #del(c)
        #del(d)
	return

    def _abort(self, *ignored):
        d,c = self.__get_con()
        d.rollback()
        del(c)
        del(d)
        
    def tables(self, rdb=0,
               _care=('TABLE', 'VIEW')):
        r=[]
        a=r.append
        for name, typ in self.db.objects():
            if typ in _care:
                a({'TABLE_NAME': name, 'TABLE_TYPE': typ})
        return r

    def columns(self, table_name):
        c=self.cursor
        try: r=c.execute('select * from %s' % table_name)
        except: return ()
        desc=c.description
        r=[]
        a=r.append
        for name, type, width, ds, p, scale, null_ok in desc:
            if type=='NUMBER' and scale==0: type='INTEGER'
            a({ 'Name': name,
                'Type': type,
                'Precision': p,
                'Scale': scale,
                'Nullable': null_ok,
                })

        return r

    def __get_con(self):
        d = PySQLRDB.connect((self.dbhost, string.atoi(self.port)), self.user, self.password)
        c = d.cursor()
        return [d,c]

    def query(self,query_string, max_rows=9999999):
        global failures, calls, last_call_time
        calls=calls+1
        desc=None
        result=()
        self._register()
        d,c = self.__get_con()
        try:
            for qs in filter(None, map(strip,split(query_string, '\0'))):
                r=c.execute(qs)
                if r is None:
                    if desc is not None:
                        if c.description != desc:
                            raise 'Query Error', (
                                'Multiple select schema are not allowed'
                                )
                        # yuck!! why can't I call type() from here????
                        if 'append' not in dir(result): result = list(result)
                        #if type(result) is not ListType: result=list(result)
                        if max_rows:
                            for row in c.fetchmany(max_rows-len(result)):
                                result.append(row)
                    else:
                        desc=c.description
                        if max_rows:
                            if max_rows==1: result=(c.fetchone(),)
                            else: result=c.fetchmany(max_rows)

            failures=0
            last_call_time=time()
        except self.Database_Error, mess:
            failures=failures+1
            if (failures > 1000 or time()-last_call_time > 600):
                # Hm. maybe the db is hosed.  Let's try once to restart it.
                failures=0
                last_call_time=time()
                print c.__class__
                c.close()
                d.close()
                return self.query(query_string, max_rows)
            else: raise sys.exc_type, sys.exc_value, sys.exc_traceback

        if desc is None:
            del(c)
            del(d)
            return (),()

        items=[]
        for name, type, length in desc:
            if type=='NUMBER':
                #if scale==0: type='i'
                #else:
                type='n'
            elif type=='DATE':
                type='d'
            else: type='s'
            items.append({
                'name': name,
                'type': type,})
                #'width': width,
                #'null': null_ok,
        del(c)
        del(d)
        return items, result


