// Copyright (c) 1999-2000  David Muse
// See the file COPYING for more information

#include <cachemanager.h>

void	cachemanager::scan(int scaninterval) {

	// some useful vars
	DIR	*dir;
	#ifdef HAVE_DIRENT_H
		dirent	*current;
	#else
		direct	*current;
	#endif

	while (1) {

		// open directory
		dir=opendir(CACHE_DIR);

		// loop through directory, erasing
		while (current=readdir(dir)) {
			if (strcmp(current->d_name,".") &&
				strcmp(current->d_name,"..")) {
				erase(current->d_name);
			}
		}

		// close the directory
		closedir(dir);

		// wait...
		sleep(scaninterval);
	}

}

void	cachemanager::erase(char *filename) {

	// derive the full pathname
	strstream	*fullpathname=new strstream();
	*fullpathname << CACHE_DIR << "/" << filename << ends;

	// open the file
	ifstream	*file=new ifstream(fullpathname->str(), 
						ios::in | ios::out);
	if (file && file->good()) {

		// get the ttl
		long ttl;
		file->read((char *)&ttl,sizeof(long));

		file->close();
		delete file;

		// delete the file if the ttl has expired
		if (ttl<time(NULL)) {
			unlink(fullpathname->str());
		}

	} else {
	
		// handle bad file
		if (file) {
			file->close();
		}
		delete file;
	}

	// clean up
	delete fullpathname;
}
