// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#ifndef FREETDSCONNECTION_H
#define FREETDSCONNECTION_H

#define NUM_CONNECT_STRING_VARS 8
#define MAXCOLUMNS 256

#include <connection.h>

#include <fstream.h>

extern "C" {
	#include <ctpublic.h>
	#include <ctfunctions.h>
}


class freetdsconnection : public connection {
	public:
			freetdsconnection();
			~freetdsconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		void	logOut();
		int	executeQuery(char *query, long length);
		char	*getErrorMessage(int *liveconnection);
		void	returnHeader();
		int	noRowsToReturn();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();
		void	initColumns();
		void	cleanUpColumns();
		int	cancelRemainingResultSets();
		int	ping();
		char	*identify();

		CS_CONTEXT	*context;
		CS_LOCALE	*locale;
		CS_CONNECTION	*conn;
		CS_COMMAND	*cmd;
		CS_INT		results_type;
		CS_INT		ncols;
		CS_INT		affectedrows;
		int		initcol;

		CS_DATAFMT	**column;
		CS_VOID		**data;
		CS_INT		*datalength;
		CS_SMALLINT	*nullindicator;

		CS_DATAFMT	*convfmt;

		char		*user;
		char		*password;
		char		*server;
		char		*charset;
		char		*language;
		char		*encryption;
		int		enc;
		char		*hostname;
		char		*packetsize;

		static	strstream	*errorstring;
		static	int		deadconnection;

		static	CS_RETCODE	clientMessageCallback(CS_CONTEXT *ctxt,
						CS_CONNECTION *cnn,
						CS_CLIENTMSG *emsgp);
		static	CS_RETCODE	serverMessageCallback(CS_CONTEXT *ctxt,
						CS_CONNECTION *cnn,
						CS_SERVERMSG *msgp);
};

#endif
