// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#ifndef DB2CCONNECTION_H
#define DB2CCONNECTION_H

#define NUM_CONNECT_STRING_VARS 4

#include <connection.h>

#include <fstream.h>
#include <strstream.h>

#include <ibase.h>

#define MAX_ITEM_BUFFER_SIZE 4096
#define MAX_SELECT_LIST_SIZE 256
#define MAX_BIND_VARS 256

struct fieldstruct {
	int		sqlrtype;
	short		type;

	short		shortbuffer;
	long		longbuffer;
	float		floatbuffer;
	double		doublebuffer;
	ISC_QUAD	quadbuffer;
	ISC_DATE	datebuffer;
	ISC_TIME	timebuffer;
	ISC_TIMESTAMP	timestampbuffer;
	ISC_INT64	int64buffer;
	char		textbuffer[MAX_ITEM_BUFFER_SIZE+1];

	short		nullindicator;
};

class interbaseconnection : public connection {
	public:
			interbaseconnection();
			~interbaseconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		void	logOut();
		int	prepareQuery(char *query, long length);
		int	inputBindValue(char *variable, short variablesize,
					char *value, short valuesize,
					short *isnull);
		int	inputBindValue(char *variable, short variablesize,
					long *value);
		int	inputBindValue(char *variable, short variablesize,
					double *value, 
					short precision,
					short scale);
		int	outputBindValue(char *variable, short variablesize,
					char *value, short valuesize,
					short *isnull);
		short	nonNullBindValue();
		short	nullBindValue();
		int	executeQuery(char *query, long length);
		int	queryIsNotSelect();
		int	queryIsCommitOrRollback();
		void	commit();
		void	rollback();
		char	*getErrorMessage(int *liveconnection);
		void	returnHeader();
		int	noRowsToReturn();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();
		int	ping();
		char	*identify();

		char		dpb[256];
		short		dpblength;
		isc_db_handle	db;
		isc_tr_handle	tr;
		isc_stmt_handle	stmt;
		XSQLDA	ISC_FAR	*outsqlda;
		XSQLDA	ISC_FAR	*insqlda;
		ISC_BLOB_DESC	to_desc;
		ISC_STATUS	error[20];

		int		querytype;

		fieldstruct	field[MAX_SELECT_LIST_SIZE];

		char		*database;
		int		dialect;
		char		*user;
		char		*password;

		strstream	*errormsg;
};

#endif
