// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#ifndef LAGOCONNECTION_H
#define LAGOCONNECTION_H

#define NUM_CONNECT_STRING_VARS 5

#include <connection.h>

#include <fstream.h>

#include <lago.h>

class lagoconnection : public connection {
	public:
			lagoconnection();
			~lagoconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		void	logOut();
		int	executeQuery(char *query, long length);
		char	*getErrorMessage(int *liveconnection);
		void	returnHeader();
		int	noRowsToReturn();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();
		int	ping();
		char	*identify();
		int	isTransactional();

		LCTX		lagocontext;
		LRST		lagoresult;
		int		ncols;
		int		nrows;
		int		affectedrows;

		char		*host;
		char		*port;
		char		*db;
		char		*user;
		char		*password;
};

#endif
