// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#ifndef MSQLCONNECTION_H
#define MSQLCONNECTION_H

#define NUM_CONNECT_STRING_VARS 2

#include <connection.h>

#include <fstream.h>

#include <msql.h>

class msqlconnection : public connection {
	public:
			msqlconnection();
			~msqlconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		void	logOut();
		int	executeQuery(char *query, long length);
		char	*getErrorMessage(int *liveconnection);
		void	returnHeader();
		int	noRowsToReturn();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();
		int	ping();
		char	*identify();
		int	isTransactional();

		int		msql;
		m_result	*msqlresult;
		m_field		*msqlfield;
		m_row		msqlrow;
		int		ncols;
		int		nrows;
		int		affectedrows;

		char		*host;
		char		*db;
};

#endif
