// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#ifndef MYSQLCONNECTION_H
#define MYSQLCONNECTION_H

#define NUM_CONNECT_STRING_VARS 6

#include <connection.h>

#include <fstream.h>
#include <strstream.h>

#include <mysql.h>

class mysqlconnection : public connection {
	public:
			mysqlconnection();
			~mysqlconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		void	logOut();
		int	executeQuery(char *query, long length);
		char	*getErrorMessage(int *liveconnection);
		void	returnHeader();
		int	noRowsToReturn();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();
		int	ping();
		char	*identify();
		int	isTransactional();

		MYSQL		mysql;
		MYSQL_RES	*mysqlresult;
		MYSQL_FIELD	*mysqlfield;
		MYSQL_ROW	mysqlrow;
		int		ncols;
		int		nrows;
		int		affectedrows;
		int		connected;
		strstream	*errmesg;

		char		*user;
		char		*password;
		char		*db;
		char		*host;
		char		*port;
		char		*socket;
};

#endif
