// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#ifndef ODBCCCONNECTION_H
#define ODBCCCONNECTION_H

#define NUM_CONNECT_STRING_VARS 3

#include <connection.h>

#include <fstream.h>
#include <strstream.h>

#include <sql.h>
#include <sqlext.h>
#include <sqltypes.h>

#define MAX_ITEM_BUFFER_SIZE 4096

struct column {
	char	name[MAX_ITEM_BUFFER_SIZE];
	int	namelength;
	int	type;
	int	length;
};

class odbcconnection : public connection {
	public:
			odbcconnection();
			~odbcconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		void	logOut();
		int	prepareQuery(char *query, long length);
		int	inputBindValue(char *variable, short variablesize,
					char *value, short valuesize,
					short *isnull);
		int	inputBindValue(char *variable, short variablesize,
					long *value);
		int	inputBindValue(char *variable, short variablesize,
					double *value, 
					short precision,
					short scale);
		int	outputBindValue(char *variable, short variablesize,
					char *value, short valuesize,
					short *isnull);
		short	nonNullBindValue();
		short	nullBindValue();
		int	executeQuery(char *query, long length);
		void	commit();
		void	rollback();
		char	*getErrorMessage(int *liveconnection);
		void	returnHeader();
		int	noRowsToReturn();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();
		int	ping();
		char	*identify();

		SQLHENV		env;
		long		erg;
		SQLHDBC		dbc;
		SQLHSTMT	stmt;
		long		result;
		SQLSMALLINT	ncols;
		SQLINTEGER 	affectedrows;
		char		field[MAX_ITEM_BUFFER_SIZE];
		SQLINTEGER	indicator;
		column 		*col;

		strstream	*errormsg;

		char		*dsn;
		char		*user;
		char		*password;
};

#endif
