// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#ifndef POSTGRESQLCONNECTION_H
#define POSTGRESQLCONNECTION_H

#define NUM_CONNECT_STRING_VARS 7

#include <connection.h>

#include <fstream.h>

#include <libpq-fe.h>

class postgresqlconnection : public connection {
	public:
			postgresqlconnection();
			~postgresqlconnection();
	private:
		int	getNumberOfConnectStringVars();
		void	handleConnectString();
		int	logIn();
		void	logOut();
		int	executeQuery(char *query, long length);
		char	*getErrorMessage(int *liveconnection);
		void	returnHeader();
		int	noRowsToReturn();
		int	fetchRow();
		void	returnRow();
		void	cleanUpData();
		int	ping();
		char	*identify();

		PGconn		*pgconn;
		PGresult	*pgresult;
		ExecStatusType	pgstatus;
		int		ncols;
		int		nrows;
		int		currentrow;

		char		*host;
		char		*port;
		char		*options;
		char		*tty;
		char		*db;
		char		*user;
		char		*password;
};

#endif
