// Copyright (c) 2000  David Muse
// See the file COPYING for more information

#ifndef SQLITECONNECTION_H
#define SQLITECONNECTION_H

#define NUM_CONNECT_STRING_VARS 1

#include <connection.h>
#include <semaphoreset.h>

#include <fstream.h>

extern "C" {
	#include <sqlite.h>
}

#include <pthread.h>

class sqliteconnection : public connection {
	public:
				sqliteconnection();
				~sqliteconnection();
	private:
			int	getNumberOfConnectStringVars();
			void	handleConnectString();
			int	logIn();
			void	logOut();
			int	executeQuery(char *query, long length);
			char	*getErrorMessage(int *liveconnection);
		static	void	runQuery(sqliteconnection *thisptr);
		static	int	handleRow(sqliteconnection *thisptr, 
						int argc, char **argv,
						char **columnames);
			void	returnHeader();
			int	noRowsToReturn();
			int	fetchRow();
			void	returnRow();
			void	cleanUpData();
			int	ping();
			char	*identify();
			int	isTransactional();

			sqlite		*sqliteptr;
			char		*errmesg;
		static	char		*query;
			int		nomorerows;
			int		ncols;
			char		**colnames;

			char		*db;

			semaphoreset	*sync;

			pthread_attr_t	attr;

			pthread_t	thread;
};

#endif
