// Copyright (c) 1999  David Muse
// See the file COPYING for more information

#ifndef LISTENER_H
#define LISTENER_H

#include <config.h>
#include <defaults.h>
#include <signalhandler.h>
#include <daemon.h>
#include <server.h>
#include <semaphoreset.h>
#include <sharedmemory.h>

#include <strstream.h>

#include <defines.h>

#define USERSIZE 128

class listener : public daemon, public server {

	public:
			listener();
			~listener();
		void	initListener(int argc, char **argv);
		void	listen();

	private:
		void	cleanUp();

		int	getAuth();
		void	getAConnection();
		void	incrementSessionCount();
		void	returnAuthError();

		void	blockSignals();
		void	handleDeadChild();

		void	openMoreConnections(int waitinglisteners);
		int	countOpenConnections();

		char		*id;
		char		*config;

		int		connections;
		int		maxconnections;
		int		maxqueuelength;
		int		growby;
		int		ttl;
		char		*runasuser;
		char		*runasgroup;
		int		dynamicscaling;

		char			*unixport;
		unsigned short int	inetport;

		int		authcount;
		char		**users;
		char		**passwords;
		char		userbuffer[USERSIZE+1];
		char		passwordbuffer[USERSIZE+1];

		char		unixportstr[MAXPATHLEN+1];
		short		unixportstrlen;

		signalhandler	*deadchildhandler;
		semaphoreset	*semset;
		sharedmemory	*idmemory;

		int		init;
};

#endif
