// Copyright (c) 1999  David Muse
// See the file COPYING for more information

#ifndef MONITOR_H
#define MONITOR_H

#include <config.h>
#include <defaults.h>

#include <configfile.h>

#include <daemon.h>
#include <semaphoreset.h>
#include <sharedmemory.h>
#include <randomnumber.h>

#include <strstream.h>


class scaler : public daemon {

	public:
			scaler();
			~scaler();
		void	initScaler(int argc, char **argv);
		void	loop();

	private:
		void	cleanUp();

		void	openMoreConnections();
		void	getRandomConnectionId();
		int	countSessions();
		int	countConnections();

		char		*id;
		char		*config;
		char		*dbase;

		int		connections;
		int		maxconnections;
		int		maxqueuelength;
		int		growby;
		int		ttl;

		strstream	*idfilename;

		semaphoreset	*semset;

		sharedmemory	*idmemory;

		configfile		*cfgfile;

		connectstringnode	*connectstringlist;
		char			*connectionid;
		int			metrictotal;

		randomnumber	*randnum;
		int		currentseed;

		int		init;
};

#endif
