<!-- Copyright (c) 2000  David Muse
     See the file COPYING for more information. -->

<? dl("sql_relay.so"); ?>

<!-- instantiation -->
INSTANTIATION<br>
<? $s=sqlrc_alloc($host,$port,$socket,$user,$password,0,1); ?>

<!-- debugOn -->
DEBUG ON<br>
<? sqlrc_debugOn($s); ?>
getDebug(): <? echo sqlrc_getDebug($s); "\n"; ?><br>


<!-- query functions -->
QUERY FUNCTIONS<br>
<?  sqlrc_sendQuery($s,$query); ?>


<!-- prepare/substutute/bind/execute functions -->
BIND FUNCTIONS<br>
<?
sqlrc_prepareQuery($s, "begin  $(result):=$(term1)+$(term2)+:term3+:term4+:term5; end;");
sqlrc_substitution($s,"result",":result");
sqlrc_substitution($s,"term1",400.0);
sqlrc_substitution($s,"term2",200);
sqlrc_inputBind($s,"term3","100");
sqlrc_inputBind($s,"term4",50);
sqlrc_inputBind($s,"term5",25.0);
sqlrc_inputBind($s,"junkterm","junkvalue");
sqlrc_defineOutputBind($s,"result",5);
sqlrc_defineOutputBind($s,"junkresult",5);
sqlrc_validateBinds($s);
sqlrc_executeQuery($s);
$result=sqlrc_getOutputBind($s,"result");
$junkresult=sqlrc_getOutputBind($s,"junkresult");
?>
result is <? echo $result; ?><br>
junkresult is <? echo $junkresult; ?><br><br>



<!-- cached query functions -->
CACHED QUERY FUNCTIONS<br>
<?
sqlrc_cacheOn($s);
sqlrc_setCacheTtl($s,1000);
sqlrc_sendQuery($s,$query);
$filename=sqlrc_getCacheFileName($s);
sqlrc_cacheOff($s);
sqlrc_openCachedResultSet($s,$filename);
?>
rowCount()     : <? echo sqlrc_rowCount($s); "\n"; ?><br>


<!-- result set functions -->
RESULT SET FUNCTIONS<br>
<? sqlrc_sendQuery($s,$query); ?>
rowCount()    : <? echo sqlrc_rowCount($s); "\n"; ?><br>
colCount()    : <? echo sqlrc_colCount($s); "\n"; ?><br>
totalRows()   : <? echo sqlrc_totalRows($s); "\n"; ?><br>
affectedRows(): <? echo sqlrc_affectedRows($s); "\n"; ?><br>


<!-- column functions -->
COLUMN FUNCTIONS<br>
<?
for ($col=0; $col<sqlrc_colCount($s); $col++) {
	echo '"', sqlrc_getColumnName($s,$col), '","', sqlrc_getColumnType($s,$col), '",', sqlrc_getColumnLength($s,$col), ',', sqlrc_getLongest($s,$col), "<br>\n";
}
?>


<!-- field functions -->
FIELD FUNCTIONS<br>
<?
for ($row=0; $row<sqlrc_rowCount($s); $row++) {
	$colcount=sqlrc_colCount($s);
	for ($col=0; $col<sqlrc_colCount($s); $col++) {
		echo '"', sqlrc_getField($s,$row,$col), '"';
		if ($col < $colcount-1) {
			echo ',';
		}
	}
	echo "<br>\n";
}
?>


<!-- row functions -->
ROW FUNCTIONS<br>
<?
for ($row=0; $row<sqlrc_rowCount($s); $row++) {
	$colcount=sqlrc_colCount($s);
	echo "Indexed<br>\n";
	$rowarray=sqlrc_getRow($s,$row);
	for ($col=0; $col<sqlrc_colCount($s); $col++) {
		echo '"', $rowarray[$col], '"';
		if ($col < $colcount-1) {
			echo ',';
		}
	}
	echo "<br>\nAssociative<br>\n";
	$rowassoc=sqlrc_getRowAssoc($s,$row);
	for ($col=0; $col<sqlrc_colCount($s); $col++) {
		echo '"', $rowassoc[sqlrc_getColumnName($s,$col)], '"';
		if ($col < $colcount-1) {
			echo ',';
		}
	}
	echo "<br>\n";
}
?>


<!-- null functions -->
NULL FUNCTIONS<br>
<?
sqlrc_getNullsAsUndefined($s);
sqlrc_sendQuery($s,'select NULL "col1", NULL "col2", NULL "col3" from dual');
for ($row=0; $row<sqlrc_rowCount($s); $row++) {
	$colcount=sqlrc_colCount($s);
	echo "Indexed<br>\n";
	$rowarray=sqlrc_getRow($s,$row);
	for ($col=0; $col<sqlrc_colCount($s); $col++) {
		if (isset($rowarray[$col])) {
			echo $col, " is defined\n";
		} else {
			echo $col, " is undefined\n";
		}
	}
	echo "<br>\nAssociative<br>\n";
	$rowassoc=sqlrc_getRowAssoc($s,$row);
	for ($col=0; $col<sqlrc_colCount($s); $col++) {
		if (isset($rowassoc[sqlrc_getColumnName($s,$col)])) {
			echo sqlrc_getColumnName($s,$col), " is defined\n";
		} else {
			echo sqlrc_getColumnName($s,$col), " is undefined\n";
		}
	}
	echo "<br>\n";
}
sqlrc_getNullsAsEmptyStrings($s);
?>


<!-- result set buffer functions -->
RESULT SET BUFFER FUNCTIONS<br>
<?  sqlrc_setResultSetBufferSize($s,3); ?>
getResultSetBufferSize(): <? echo sqlrc_getResultSetBufferSize($s), "<br>\n"; ?>
<?
sqlrc_sendQuery($s,$query);
$field=sqlrc_getField($s,0,0);
?>
getField(0,0)  : <? echo $field, "<br>\n"; ?>
<? $field=sqlrc_getField($s,100,0); ?>
getField(100,0): <? echo $field, "<br>\n"; ?>


<!-- cached result set with offset functions -->
CACHED RESULT SET WITH OFFSET FUNCTIONS<br>
<?
sqlrc_setResultSetBufferSize($s,0);
sqlrc_cacheOn($s);
sqlrc_setCacheTtl($s,1000);
sqlrc_sendQuery($s,$query);
$filename=sqlrc_getCacheFileName($s);
sqlrc_cacheOff($s);
sqlrc_setResultSetBufferSize($s,3);
sqlrc_openCachedResultSet($s,$filename);
$field=sqlrc_getField($s,5,0);
?>
getField(5,0)  : <? echo sqlrc_getField($s,5,0), "\n"; ?><br>
rowCount()     : <? echo sqlrc_rowCount($s); "\n"; ?><br>
<?
$offset=sqlrc_getCacheFileOffset($s);
$row=sqlrc_rowCount($s);
?>
offset: <? echo $offset, "<br>\n"; ?>
row   : <? echo $row, "<br>\n"; ?>
<? sqlrc_openCachedResultSetWithOffset($s,$filename,$offset,$row); ?>
getField(8,0)  : <? echo sqlrc_getField($s,8,0), "\n"; ?><br>
rowCount()     : <? echo sqlrc_rowCount($s); "\n"; ?><br>


<!-- suspended session -->
SUSPENDED SESSION<br>
<?
sqlrc_setResultSetBufferSize($s,3);
sqlrc_sendQuery($s,$query);
$port=sqlrc_getConnectionPort($s);
$socket=sqlrc_getConnectionSocket($s);
sqlrc_suspendSession($s);
sqlrc_resumeSession($s,$port,$socket);
?>
firstRowIndex         : <? echo sqlrc_firstRowIndex($s), "<br>\n"; ?>
<? $field=sqlrc_getField($s,0,0); ?>
getField(0,0)  : <? echo $field, "<br>\n"; ?>
<? $field=sqlrc_getField($s,5,0); ?>
getField(5,0)  : <? echo $field, "<br>\n"; ?>
<? $field=sqlrc_getField($s,6,0); ?>
getField(6,0)  : <? echo $field, "<br>\n"; ?>
<? $field=sqlrc_getField($s,100,0); ?>
getField(100,0)  : <? echo $field, "<br>\n"; ?>



<!-- suspended cached session -->
SUSPENDED CACHED SESSION<br>
<?
sqlrc_setResultSetBufferSize($s,3);
sqlrc_cacheOn($s);
sqlrc_setCacheTtl($s,1000);
sqlrc_sendQuery($s,$query);
$filename=sqlrc_getCacheFileName($s);
sqlrc_cacheOff($s);
$port=sqlrc_getConnectionPort($s);
$socket=sqlrc_getConnectionSocket($s);
sqlrc_suspendSession($s);
sqlrc_resumeCachedSession($s,$port,$socket,$filename);
sqlrc_endSession($s);
sqlrc_setResultSetBufferSize($s,0);
sqlrc_openCachedResultSet($s,$filename);
?>


<!-- ping and identify -->
PING AND IDENTIFY<br>
identify: <? echo sqlrc_identify($s); ?><br>
ping: <? echo sqlrc_ping($s); ?><br>

<!-- debugOff -->
DEBUG OFF<br>
<? sqlrc_debugOff($s); ?>
getDebug(): <? echo sqlrc_getDebug($s); "\n"; ?><br>

<? sqlrc_free($s); ?>
